"use strict";

var noop = require("./_noop");

var once = require("./_once");

module.exports = function ($cancelToken, emitter, arrayArg) {
  var add = emitter.addEventListener || emitter.addListener || emitter.on;

  if (add === undefined) {
    throw new Error("cannot register event listener");
  }

  var remove = emitter.removeEventListener || emitter.removeListener || emitter.off;
  var eventsAndListeners = [];
  var clean = noop;

  if (remove !== undefined) {
    clean = once(function () {
      for (var i = 0, n = eventsAndListeners.length; i < n; i += 2) {
        remove.call(emitter, eventsAndListeners[i], eventsAndListeners[i + 1]);
      }
    });
    $cancelToken.promise.then(clean);
  }

  return arrayArg ? function (eventName, cb) {
    function listener() {
      clean();
      var event = Array.prototype.slice.call(arguments);
      event.args = event;
      event.event = event.name = eventName;
      cb(event);
    }

    eventsAndListeners.push(eventName, listener);
    add.call(emitter, eventName, listener);
  } : function (event, cb) {
    var listener = function listener(arg) {
      clean();
      cb(arg);
    };

    eventsAndListeners.push(event, listener);
    add.call(emitter, event, listener);
  };
};