"use strict";

var isProgrammerError = require("./_isProgrammerError");

module.exports = function matchError(predicate, error) {
  if (predicate === undefined) {
    return !isProgrammerError(error);
  }

  if (typeof predicate === "function") {
    return predicate === Error || predicate.prototype instanceof Error ? error instanceof predicate : predicate(error);
  }

  if (Array.isArray(predicate)) {
    var n = predicate.length;

    for (var i = 0; i < n; ++i) {
      if (matchError(predicate[i], error)) {
        return true;
      }
    }

    return false;
  }

  if (error != null && typeof predicate === "object") {
    for (var key in predicate) {
      if (hasOwnProperty.call(predicate, key) && error[key] !== predicate[key]) {
        return false;
      }
    }

    return true;
  }
};