"use strict";

var isPromise = require("./isPromise");

module.exports = function delay(ms) {
  var value = arguments.length === 2 ? arguments[1] : this;

  if (isPromise(value)) {
    return value.then(function (value) {
      return new Promise(function (resolve) {
        setTimeout(resolve, ms, value);
      });
    });
  }

  var handle;
  var p = new Promise(function (resolve) {
    handle = setTimeout(resolve, ms, value);
  });

  p.unref = function () {
    if (handle != null && typeof handle.unref === "function") {
      handle.unref();
    }

    return p;
  };

  return p;
};