"use strict";

function resolver(fn, args, resolve, reject) {
  args.push(function (error, result) {
    return error != null && error !== false ? reject(error) : resolve(result);
  });
  fn.apply(this, args);
}

module.exports = function fromCallback(fn) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return new Promise(resolver.bind(this, typeof fn === "function" ? fn : this[fn], args));
};