"use strict";

var cancelable = require("./cancelable");

var makeEventAdder = require("./_makeEventAdder");

var fromEvent = cancelable(function ($cancelToken, emitter, event, opts) {
  if (opts === void 0) {
    opts = {};
  }

  return new Promise(function (resolve, reject) {
    var add = makeEventAdder($cancelToken, emitter, opts.array);
    add(event, resolve);

    if (!opts.ignoreErrors) {
      var _opts = opts,
          _opts$error = _opts.error,
          error = _opts$error === void 0 ? "error" : _opts$error;

      if (error !== event) {
        add(error, reject);
      }
    }
  });
});
module.exports = fromEvent;