"use strict";

var cancelable = require("./cancelable");

var makeEventAdder = require("./_makeEventAdder");

var _require = require("./_utils"),
    forArray = _require.forArray;

var fromEvents = cancelable(function ($cancelToken, emitter, successEvents, errorEvents) {
  if (errorEvents === void 0) {
    errorEvents = ["error"];
  }

  return new Promise(function (resolve, reject) {
    var add = makeEventAdder($cancelToken, emitter, true);
    forArray(successEvents, function (event) {
      return add(event, resolve);
    });
    forArray(errorEvents, function (event) {
      return add(event, reject);
    });
  });
});
module.exports = fromEvents;