"use strict";

var isArray = Array.isArray,
    slice = Array.prototype.slice;

var chain = function chain(promise, fn) {
  return promise.then(fn);
};

module.exports = function pPipe(fns) {
  if (!isArray(fns)) {
    fns = slice.call(arguments);
  }

  if (typeof fns[0] !== "function") {
    fns[0] = Promise.resolve(fns[0]);
    return fns.reduce(chain);
  }

  return function (arg) {
    return fns.reduce(chain, Promise.resolve(arg));
  };
};