"use strict";

var promisify = require("./promisify");

var _require = require("./_utils"),
    forIn = _require.forIn;

var DEFAULT_MAPPER = function DEFAULT_MAPPER(_, name) {
  return !(name.endsWith("Sync") || name.endsWith("Async")) && name;
};

var promisifyAll = function promisifyAll(obj, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$mapper = _ref.mapper,
      mapper = _ref$mapper === void 0 ? DEFAULT_MAPPER : _ref$mapper,
      _ref$target = _ref.target,
      target = _ref$target === void 0 ? {} : _ref$target,
      _ref$context = _ref.context,
      context = _ref$context === void 0 ? obj : _ref$context;

  forIn(obj, function (value, name) {
    var newName;

    if (typeof value === "function" && (newName = mapper(value, name, obj))) {
      target[newName] = promisify(value, context);
    }
  });
  return target;
};

module.exports = promisifyAll;