"use strict";

var FN_FALSE = function FN_FALSE() {
  return false;
};

var FN_TRUE = function FN_TRUE() {
  return true;
};

var onFulfilled = function (__proto__) {
  return function (_value) {
    return {
      __proto__: __proto__,
      value: function value() {
        return _value;
      }
    };
  };
}({
  isFulfilled: FN_TRUE,
  isPending: FN_FALSE,
  isRejected: FN_FALSE,
  reason: function reason() {
    throw new Error("no reason, the promise has resolved");
  }
});

var onRejected = function (__proto__) {
  return function (_reason) {
    return {
      __proto__: __proto__,
      reason: function reason() {
        return _reason;
      }
    };
  };
}({
  isFulfilled: FN_FALSE,
  isPending: FN_FALSE,
  isRejected: FN_TRUE,
  value: function value() {
    throw new Error("no value, the promise has rejected");
  }
});

module.exports = function () {
  return this.then(onFulfilled, onRejected);
};