"use strict";

var resolve = require("./_resolve");

var _require = require("./_utils"),
    forEach = _require.forEach;

var _some = function _some(promises, count) {
  return new Promise(function (resolve, reject) {
    var values = [];
    var errors = [];

    var onFulfillment = function onFulfillment(value) {
      if (!values) {
        return;
      }

      values.push(value);

      if (--count === 0) {
        resolve(values);
        values = errors = undefined;
      }
    };

    var acceptableErrors = -count;

    var onRejection = function onRejection(reason) {
      if (!values) {
        return;
      }

      errors.push(reason);

      if (--acceptableErrors === 0) {
        reject(errors);
        values = errors = undefined;
      }
    };

    forEach(promises, function (promise) {
      ++acceptableErrors;
      resolve(promise).then(onFulfillment, onRejection);
    });
  });
};

module.exports = function some(count) {
  return resolve(this).then(function (promises) {
    return _some(promises, count);
  });
};