"use strict";

var setFunctionNameAndLength = require("./_setFunctionNameAndLength");

module.exports = function unpromisify() {
  var fn = this;
  return setFunctionNameAndLength(function () {
    var n = arguments.length - 1;
    var cb;

    if (n < 0 || typeof (cb = arguments[n]) !== "function") {
      throw new Error("missing callback");
    }

    var args = new Array(n);

    for (var i = 0; i < n; ++i) {
      args[i] = arguments[i];
    }

    fn.apply(this, args).then(function (result) {
      return cb(undefined, result);
    }, function (reason) {
      return cb(reason);
    });
  }, fn.name, fn.length + 1);
};